program Code;

procedure Euklides(m, n : Integer; var d, s, t : Integer);
  var
    p, q, a1, a2, s1, s2, t1, t2 : Integer;
  begin
    a1 := m; a2 := n; s1 := 1; s2 := 0; t1 := 0; t2 := 1;
    while a2 <> 0 do begin
      q := a1 div a2;
      p := a2; a2 := a1 - q * a2; a1 := p;
      p := s2; s2 := s1 - q * s2; s1 := p;
      p := t2; t2 := t1 - q * t2; t1 := p;
    end;
    d := a1; s := s1; t := t1;
  end;
  
var
  A: array [0..100] of Integer;
  BI: Integer;
  BR: Integer;
  D1: Integer;
  D2: Integer;
  I: Integer;
  NWD: Integer;
  WspBI: Integer;
  WspBR: Integer;
  XI: Integer;
  XR: Integer;
  YI: Integer;
  YR: Integer;
  ZI: Integer;
  ZR: Integer;
 
procedure Go(N: Integer);

begin
  if (XR = 0) and (XI = 0) then
  begin
    for I := N - 1 downto 1 do
      Write(A[I]:1, ',');
    Writeln(A[0]:1);
  end
  else if N = 101 then
    Writeln('The code cannot be decrypted.')
  else if XI mod NWD <> 0 then
    Writeln('The code cannot be decrypted.')
  else
  begin
    YR := WspBI * (XI div NWD);
    YI := WspBR * (XI div NWD);
    ZR :=  BR div NWD;
    ZI := -BI div NWD;
    D1 := BR * ZR - BI * ZI;
    D2 := (XR - (BR * YR - BI * YI)) div D1;
    Inc(YR, D2 * ZR);
    Inc(YI, D2 * ZI);
    if D1 > 0 then
    begin
      Inc(YR, ZR);
      Inc(YI, ZI);
    end
    else
    begin
      Dec(YR, ZR);
      Dec(YI, ZI);
    end;      
    while BR * YR - BI * YI > XR do
      if D1 > 0 then
      begin
        Dec(YR, ZR);
        Dec(YI, ZI);
      end
      else
      begin
        Inc(YR, ZR);
        Inc(YI, ZI);
      end;      
    if (XR - (BR * YR - BI * YI)) * (XR - (BR * YR - BI * YI)) >=  
        BR * BR + BI * BI then
      Writeln('The code cannot be decrypted.')
    else
    begin
      A[N] := XR - (BR * YR - BI * YI);
      XR := YR;
      XI := YI;
      Go(N + 1);
    end;
  end;
end;

var
  P: Integer;
  T: Integer;
  
begin
  Readln(T);
  for P := 1 to T do
  begin
    Read(XR);
    Read(XI);
    Read(BR);
    Readln(BI);
    Euklides(Abs(BR), Abs(BI), NWD, WspBR, WspBI);
    if BR < 0 then
      WspBR := -WspBR;
    if BI < 0 then
      WspBI := -WspBI;
    A[0] := 0;
    Go(0);
  end;
end.