program Words;

var
  FindUnion: array ['a'..'z'] of Integer;
  
function Find(C: Char): Char;

var
  CY, CZ: Char;
  
begin
  CY := C;
  while FindUnion[CY] >= 0 do
    CY := Chr(FindUnion[CY]);
  while FindUnion[C] >= 0 do
  begin
    CZ := Chr(FindUnion[C]);
    FindUnion[C] := Ord(CY);
    C := CZ;
  end;
  Find := CY;
end;

procedure Union(C1: Char;
                C2: Char);

begin
  C1 := Find(C1);
  C2 := Find(C2);
  if (C1 <> C2) then
  begin
    if FindUnion[C1] < FindUnion[C2] then
    begin
      Inc(FindUnion[C1], FindUnion[C2]);
      FindUnion[C2] := Ord(C1);
    end
    else
    begin
      Inc(FindUnion[C2], FindUnion[C1]);
      FindUnion[C1] := Ord(C2);
    end;
  end;
end;

var
  Balance: array ['a'..'z'] of Integer;
  Edges: array ['a'..'z'] of Integer;
  C: Char;
  Ch: Char;
  I: Integer;  
  J: Integer;
  N: Integer;
  NumOdd: Integer;
  T: Integer;
  S: string [1000];
  
begin
  Read(T);
  for I := 1 to T do
  begin
    for C := 'a' to 'z' do
    begin
      Balance[C] := 0;
      FindUnion[C] := -1;
      Edges[C] := 0;
    end;
    readln;
    Read(N);
    for J := 1 to N do
    begin
      readln;
      Read(C);
      Inc(Edges[C]);
      Inc(Balance[C]);
      while not EOLN do
        Read(Ch);
      Inc(Edges[Ch]);
      Dec(Balance[Ch]);
      Union(C, Ch);
    end;
    C := 'a';
    while Edges[C] = 0 do
      Inc(C);
    NumOdd := 0;
    for Ch := 'a' to 'z' do
      if Edges[Ch] <> 0 then
      begin
        if Find(C) <> Find(Ch) then
	  Inc(NumOdd, 3)
        else 
	  Inc(NumOdd, Abs(Balance[Ch]));
      end;
    if NumOdd <= 2 then
      Writeln('Ordering is possible.')
    else
      Writeln('The door cannot be opened.');
  end;  
end.